#!/usr/bin/perl

##### 'XMSG' script developed by the-me on irc.quakenet.org ( #Linux-Dev ) Version 1.1
##### This program is free software; you can redistribute it and/or modify
##### it under the terms of the GNU General Public License as published by
##### the Free Software Foundation; either version 2 of the License, or
##### (at your option) any later version.
##### This program is distributed in the hope that it will be useful,
##### but WITHOUT ANY WARRANTY; without even the implied warranty of
##### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##### GNU General Public License for more details.
##### You should have received a copy of the GNU General Public License
##### along with this program; if not, write to the Free Software
##### Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

### Xchat registers and hooks.

Xchat::register("irc.quakenet.org:6667 #Linux-Dev XMSG Script for XChat", "1.1", "This is the /xmsg Perlscript for XChat", "");
Xchat::print"» Loaded XMSG Version 1.1 from 'the-me' on irc.quakenet.org @ #Linux-Dev - Try /xmsg_help. «";
Xchat::hook_command("xmsg", "xmsg_main");
Xchat::hook_command("xme", "xme_main");
Xchat::hook_command("xmsg_add", "xmsg_add");
Xchat::hook_command("xmsg_del", "xmsg_del");
Xchat::hook_command("xmsg_list", "xmsg_list");
Xchat::hook_command("xmsg_help", "xmsg_help");

use warnings;
use strict;

my @blacklist;
my $xdir = Xchat::get_info("xchatdir");
my $config = "$xdir/xmsg.conf";
&xmsg_get_config();

### Routine to add a channel to the blacklist.

sub xmsg_add {
	my $added = 0;
	my $channel = $_[0][1];
	unless(defined $channel){
		Xchat::print"..:: You have to enter a channel to add. Have a look at /xmsg_help please. ::..";
		return 1;
	}
	if($channel =~ "#"){
		foreach my $testifadded (@blacklist){
			if(uc($testifadded) eq uc($channel)){
				$added = 1;
			}
		}
		if($added == 0){
			push(@blacklist,$channel);
			&xmsg_save_conf();
			Xchat::print"..:: I added $channel to the blacklist. ::..";
			return 1;
		} else {
			Xchat::print"..:: The channel $channel is already added to the blacklist! ::..";
			return 1;
		}
	} else {
		Xchat::print"..:: $channel isn't a valid channelname. ::..";
		return 1;
	}
	return 1;
}

### Routine to delete an entry of the blacklist.

sub xmsg_del {
	my $channel = $_[0][1];
	unless(defined $channel){
		Xchat::print"..:: You have to enter a channel to del it. Have a look at /xmsg_help please. ::..";
		return 1;
	}
	foreach my $tempdel (@blacklist){
		if(uc($tempdel) eq uc($channel)){
			@blacklist = grep{$_ ne "$channel"} @blacklist;
			Xchat::print"..:: I removed $channel from the blacklist. ::..";
			&xmsg_save_conf();
			return 1;
		}
	}
	Xchat::print"..:: I can't find the channel $channel at the blacklist. ::..";
	return 1;
}

### Main routine for xmsg.

sub xmsg_main {
	my $counter = my $counter2 = 0;
	my $msg = $_[1][1];
	my $oldcontext = Xchat::get_context();
	unless(defined $msg){
		Xchat::print"..:: You didn't enter a message. Have a look at /xmsg_help please. ::..";
		return 1;
	}
	my @channels = Xchat::get_list('channels');
	foreach my $getnames (@channels){
		my $listed = 0;
		my $chan = $getnames->{'channel'};
		my $type = $getnames->{'type'};
		if($type == 2){
			foreach my $checkblacklist (@blacklist){
				if(uc($checkblacklist) eq uc($chan)){
					$listed = 1;
				}
			}
			if($listed == 1){
				$counter2++;
			}
			elsif($listed == 0){
				Xchat::set_context("$chan");
				Xchat::command("say $msg");
				$counter++;
			}
			Xchat::set_context("$oldcontext");
		}
	}
	Xchat::print"..:: Posted the message successful in $counter channels. I didn't post the message to $counter2 blacklisted channels. ::..";
	return 1;
}

### Main routine for xmsg.

sub xme_main {
	my $counter = my $counter2 = 0;
	my $msg = $_[1][1];
	my $oldcontext = Xchat::get_context();
	unless(defined $msg){
		Xchat::print"» You didn't enter a message. Have a look at /xmsg_help please. «";
		return 1;
	}
	my @channels = Xchat::get_list('channels');
	foreach my $getnames (@channels){
		my $listed = 0;
		my $chan = $getnames->{'channel'};
		my $type = $getnames->{'type'};
		if($type == 2){
			foreach my $checkblacklist (@blacklist){
				if(uc($checkblacklist) eq uc($chan)){
					$listed = 1;
				}
			}
			if($listed == 1){
				$counter2++;
			}
			elsif($listed == 0){
				Xchat::set_context("$chan");
				Xchat::command("me $msg");
				$counter++;
			}
			Xchat::set_context("$oldcontext");
		}
	}
	Xchat::print"..:: Posted the action successful in $counter channels. I didn't post the action to $counter2 blacklisted channels. ::..";
	return 1;
}

### Routine to list all entrys.

sub xmsg_list {
	my $counter = 0;
	Xchat::print"..:: All listed channels: ::..";
	foreach my $temp (@blacklist){
		$counter++;
		Xchat::print"$temp";
	}
	Xchat::print"..:: $counter channels are added. ::..";
	Xchat::print"..:: End of the list. ::..";
	return 1;
}

### Filecheck routine.

sub xmsg_get_config {
	if(!-e "$config"){
		open(CREATE, ">$config");
		close(CREATE);
	}
	open(GETENTRYS, "<$config");
	my @entrys = (<GETENTRYS>);
	close(GETENTRYS);
	open(SAVE, ">$config");
	foreach my $temp (@entrys){
		chomp($temp);
		push(@blacklist, $temp);
		print SAVE "$temp\n";
	}
	close(SAVE);
	return 1;
}

### Saveroutine.

sub xmsg_save_conf {
	open(SC, ">$config");
	foreach my $temp (@blacklist){
		chomp($temp);
		if($temp != ''){
			print SC "$temp\n";
		}
	}
	close(SC);
	return 1;
}

### Little helproutine.

sub xmsg_help {
	Xchat::print <<END;
..:: /xmsg » This will send your message to all channels, but not to blacklisted ones. Use: /xmsg <message>. ::..
..:: /xme » This will send a global action to all channels, but not to blacklisted ones. Use: /xme <message>. ::..
..:: /xmsg_help » This will list this little help. ::..
..:: /xmsg_list » This will list all blacklisted channels. ::..
..:: /xmsg_add » This will add a channel to the blacklist. Use: /xmsg_add <#channel>. ::..
..:: /xmsg_del » This will delete a channel from the blacklist. Use: /xmsg_del <#channel>. ::..
END
	return 1;
}

#####
##### That's all, folks!
#####